%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                   Explicit_TR.m
%                   Russell Luke
%               Department of MathSci
%              University of Delaware  
%                  July 28, 2008 
%
%
%
%
% DESCRIPTION:  TO DO
% 
%  Stable Explicit Trust Region for Symmetric PSD matrix secant methods
%
% INPUT:
%       TO DO
%
% OUTPUT:
%        TO DO
%
% USAGE: 
%
%       d_vec=Explicit_TR(Hessian_product,invHessian_product,dim,mem,grad_vec,ngrad,...
%                   S_mat, Y_mat, tr, del,alpha)
%
% SUBROUTINE CALLS:
%      
%      
% Explicit subroutine for limited memory trust region methods

function d_vec = Explicit_TR(Hessian_product,invHessian_product,dim,mem,grad_vec, ngrad, S_mat, Y_mat, tr, del,alpha, verbose)

% Hessian_product is not needed, but to maintain the same number of inputs as
% other methods, we leave it in.

% if(strcmp(Hessian_product,'BFGS1_product'))
TRsub='TRBFGS1';
% elseif(strcmp(Hessian_product,'invBFGS2_product'))
%     TRsub='TRBFGS2';
% end
dn_vec = feval(invHessian_product,dim,mem,-grad_vec, S_mat, Y_mat,del, alpha);
if norm(dn_vec) <= tr % to turn on  set <= 1e+15
    d_vec = dn_vec;
else
    if(verbose)
        disp('in trust region subproblem')
    end
    d_vec = feval(TRsub,dim,mem,-grad_vec, ngrad, S_mat, Y_mat, tr, del);
end

