function v_vec = inv_tGammPhiTPhi_product(dim,mem,u_vec,S_mat,Y_mat,delinv,omega)

% Build the pieces:
tau        = delinv + omega;
Yt_mat     = Y_mat';
YtY_mat    = Yt_mat*Y_mat;
St_mat     = S_mat';
StS_mat    = St_mat*S_mat;
StY_mat    = St_mat*Y_mat;
D_mat      = diag(diag(StY_mat));
Rbar_mat   = triu(StY_mat,0);
L_mat      = tril(StY_mat,-1);
K_mat      = YtY_mat +tau*D_mat;
[K_mat,p]  = chol(K_mat,'lower');
if(p~= 0)
    disp('Not positive definite')
end
Kt_mat     = K_mat';
E_mat      = delinv*Rbar_mat - omega*L_mat;
Et_mat     = E_mat';
B_mat      = omega*delinv*StS_mat + E_mat*(Kt_mat\(K_mat\Et_mat));
[B_mat,p]  = chol(B_mat,'lower');
if(p~= 0)
    disp('Not positive definite')
end
Bt_mat     = B_mat';

% Execute inverse multiplication:
% M_mat =  [omega*delinv*StS_mat, omega*L_mat - delinv*Rbar_mat;... 
%    (omega*L_mat - delinv*Rbar_mat)', -(tau*D_mat + YtY_mat)];
% v_vec = M_mat\u_vec; % this is believable

u01_vec = u_vec(1:mem);
u02_vec = u_vec(mem+1:2*mem);

u11_vec = B_mat\u01_vec;
u11_vec = Bt_mat\u11_vec;

u21_vec = E_mat*u11_vec;
u21_vec = K_mat\u21_vec;
u21_vec = Kt_mat\u21_vec;

u12_vec = K_mat\u02_vec;
u12_vec = Kt_mat\u12_vec;

u22_vec = E_mat*u12_vec;
u22_vec = B_mat\u22_vec;
u22_vec = Bt_mat\u22_vec;

u32_vec = Et_mat*u22_vec;
u32_vec = K_mat\u32_vec;
u32_vec = Kt_mat\u32_vec;

v_vec   = (u11_vec - u22_vec);
v_vec = [v_vec;u32_vec - u21_vec - u12_vec];


