function [f,Jf]=Burke_func(x)
   % y is a mapping from R7 into R8
    y(1)=105-4*x(1)-5*x(2)+3*x(7)^2;
    y(2)=-10*x(1)+8*x(3)+x(7);
    y(3)=8*x(1)-2*x(2)+12*x(5)-5;
    y(4)=-3*(x(1)-2)^2 -4*(x(2)-3)^2-2*x(3)^2+7*x(4)+100;
    y(5)=-5*x(1)^2-8*x(2)-(x(3)-6)^2+2*x(4)+40;
    y(6)=-.5*(x(1)-8)^2-2*(x(2)-4)^2-3*x(5)^2+x(6)+30;
    y(7)=-x(1)^2-2*(x(2)-2)^2+2*x(1)*x(2)-14*x(5)+6*x(6);
    y(8)=3*x(1)-6*x(2)-12*x(5)*x(6);
    y=y';

 
% f is a mapping from R8 to R1.
    
    f=(0.5)*norm(y)^2;

% Jacobian of y:
Jy=[-4 -5 0 0 0 0 6*x(7);
-10 0 8 0 0 0 1;
8 -2 0 0 12 0 0;
-6*(x(1)-2) -8*(x(2)-3) -4*x(3) 7 0 0 0;
-10*x(1) -8 -2*(x(3)-6) 2 0 0 0;
-(x(1)-8) -4*(x(2)-4) 0 0 -6*x(5) 1 0;
-2*x(1)+2*x(2) -4*(x(2)-2)+2*x(1) 0 0 -14 6 0;
3 -6 0 0 -12*x(6) -12*x(5) 0];

% The gradient of f is then...
Jf=Jy'*y;



